const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const locations = sequelize.define(
    'locations',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

market: {
        type: DataTypes.TEXT,
      
      

      },

timezone: {
        type: DataTypes.TEXT,
      
      

      },

address_line_1: {
        type: DataTypes.TEXT,
      
      

      },

city: {
        type: DataTypes.TEXT,
      
      

      },

state: {
        type: DataTypes.TEXT,
      
      

      },

postal_code: {
        type: DataTypes.TEXT,
      
      

      },

active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  locations.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity







    db.locations.hasMany(db.role_assignments, {
      as: 'role_assignments_location',
      foreignKey: {
          name: 'locationId',
      },
      constraints: false,
    });







    db.locations.hasMany(db.authorization_cases, {
      as: 'authorization_cases_location',
      foreignKey: {
          name: 'locationId',
      },
      constraints: false,
    });





    db.locations.hasMany(db.tasks, {
      as: 'tasks_location',
      foreignKey: {
          name: 'locationId',
      },
      constraints: false,
    });


    db.locations.hasMany(db.denials, {
      as: 'denials_location',
      foreignKey: {
          name: 'locationId',
      },
      constraints: false,
    });


    db.locations.hasMany(db.appeals, {
      as: 'appeals_location',
      foreignKey: {
          name: 'locationId',
      },
      constraints: false,
    });








    db.locations.hasMany(db.audit_logs, {
      as: 'audit_logs_location',
      foreignKey: {
          name: 'locationId',
      },
      constraints: false,
    });



    db.locations.hasMany(db.contacts, {
      as: 'contacts_location',
      foreignKey: {
          name: 'locationId',
      },
      constraints: false,
    });



//end loop



    db.locations.belongsTo(db.organizations, {
      as: 'organization',
      foreignKey: {
        name: 'organizationId',
      },
      constraints: false,
    });




    db.locations.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.locations.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return locations;
};


